# Lab №1
## Работа с Git

#### Создаю пустой репозиторий:
`git init`
##### Oтвет:
`Initialized empty Git repository in C:/PythonProject/Oap_labs_python/.git/`

#### Создаю новую ветку репозитория:
`git checkout -b lab1`
##### Oтвет:
`Switched to a new branch 'lab1'`

#### Создаю файл .gitignore и закидываю в этот файл игнорируемые каталоги и файлы.

#### Теперь перейдём к инициализации пользователя:
```
git config --global user.name "Имя пользователя"
git config --global user.mail "Эмеил пользователя"
```
> Учитываем, что команду --global можно вводить только на личном ПК

#### Для создания первого комита нам нужно добавить наши файлы(я делаю это выборочно)
`git add .  <или же имя файла без точки>`

#### Сделаем небольшую проверку чтобы не запушить ничего лишнего:
`git status`
##### Oтвет:
```
On branch lab1

No commits yet

Changes to be committed:
  (use "git rm --cached <file>..." to unstage)
        new file:   readme.md
```

#### Теперь мы готовы создать наш первый коммит:
`git commit -m "название коммита"`
##### Oтвет:
```
[lab1 (root-commit) c4d8673] lab1
 1 file changed, 51 insertions(+)
 create mode 100644 readme.md
```

#### Далее добавляю ссылку на внешний репозиторий:
`git remote add origin <ссылка>`


#### И наконец пушим наш коммит на внешний репозиторий:
`git push -u origin <имя ветки>`
##### Oтвет:
```
Enumerating objects: 3, done.
Counting objects: 100% (3/3), done.
Delta compression using up to 2 threads
Compressing objects: 100% (2/2), done.
Writing objects: 100% (3/3), 1.28 KiB | 131.00 KiB/s, done.
Total 3 (delta 0), reused 0 (delta 0), pack-reused 0
To https://kolei.ru/dpokatski/OAP
 * [new branch]      lab1 -> lab1
branch 'lab1' set up to track 'origin/lab1'.
```

### Вот несколько основных команд Git которые помогут в дальнейшем:

`git diff`
> Команда git diff используется для вычисления разницы между любыми двумя Git деревьями.

`git difftool`
> Команда git difftool просто запускает внешнюю утилиту сравнения для показа различий в двух деревьях, 
> на случай если вы хотите использовать что-либо отличное от встроенного просмотрщика git diff.

`git reset`
> Команда git reset, как можно догадаться из названия, используется в основном для отмены изменений.

`git rm`
> Команда git rm используется в Git для удаления файлов из индекса и рабочей копии.

`git mv`
> Команда git mv — это всего лишь удобный способ переместить файл, а затем выполнить git add для нового файла 
> и git rm для старого.

`git clean`
> Команда git clean используется для удаления мусора из рабочего каталога.